//+------------------------------------------------------------------+
//|                               PipNailer DashBoardEquity_v1.4.mq4 |
//|                                                   2008 SwingMan |
//|modified by Andrew andrzej_endler@post.pl                                                                  |
//+------------------------------------------------------------------+
#property copyright " 2008 SwingMan"
#property link      ""

#property indicator_separate_window

//---- extern inputs -------------------------------------------------
//- This is where you add the currency pairs you want 
extern string PairsList1 = "AUDCAD,AUDJPY,AUDUSD,CADJPY,CHFJPY,EURAUD,EURCAD,EURCHF,EURGBP,EURJPY,EURUSD,";
extern string PairsList2 = "GBPCHF,GBPJPY,GBPUSD,NZDCHF,NZDJPY,NZDUSD,USDCAD,USDCHF,USDJPY,AUDNZD";
//extern string PairsList3 = "GLD,SLV,OIL";
extern string PairsList3 = "";
extern string SystemList="";
//- If your broker names the currency pairs with a suffix for a mini account (like an "m", for example), enter the suffix here
extern string SymbolSuffix = "m";
//extern string TimeFrameList = "5,15,30,60,240,1440,10080";
extern string com="------ ActTF - time frame actualization of dashbord <0 every tick";
extern int ActTF=-1;
extern int col_display=12;
//datetime Begin_Backtest = D'2000.12.01 0:00';
//bool UseOnlyATRfactors_forSLTP = true;
//double ATRFactor_SL = 3.0;
//double ATRFactor_TP = 3.0;
//double SAR_Step = 0.02;
//double SAR_Max  = 0.2;
//bool Take2ParabolicSignals = false;
//double SAR_Step2 = 0.005;
//double SAR_Max2  = 0.2;
//--------------------------------------------------------------------
int TimeFrame;

//---- constants
string windowsName = "Systems DashBoard";
string sLabelCode = "PipNailerDBEq4_";
string sNameTradeSimulator = "PipNailer oTradeSimulator_v1.4";
int Corner_LeftUp = 0;
int Corner_RightUp = 1;
int Corner_LeftDn = 2;
int Corner_RightDn = 3;
int ShiftSignals = 1;

//---- colors
color colorTitle = DodgerBlue;
color colorTime = White;
color colorPlusEquity = DeepSkyBlue;
color colorMinusEquity = Magenta;
color colorZeroEquity = Gray;
//---- variables
string PairsList;
string Pair[30]; //Pairs array
double PairPrice[30];

string Systems[30];

int NumberSymbols, NumberTimeFrames,NumberSystems;
int iWindow, iCorner;
int xCol[50], yRow[50];
string Title1[50], Title2[50];
datetime oldTime, thisTime;
bool CurrentTimeFrameOK;
double iTimeFrame[10];
string sTimeFrame[10];

//---- initialisations
int nTitles = 30;

int xLeftTitle = 20;
int xCurrentTime = 3; 

int yCurrentTime = 15;
int yTitle1 = 30;
int yTitle2 = 50;

int rowStep = 20;
int colStep = 80;
int colStepTimeFrames = 90;

int colDB_Pairs, colDB_Spread;
int colDB_Close, colDB_LastPrice;
int iColDB_First, colDB_M5, colDB_M15, colDB_M30, colDB_H1, colDB_H4, colDB_D1, colDB_W1;
bool TradeSimulatorFinished;
int newColStep, yLastRow;

//-- Signal buffers
double Equity[30][10], EquityPairs[30][10], SumPairs[30];
double SumeEquity[10];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{ 
   PairsList = StringConcatenate(PairsList1,PairsList2,PairsList3);
   iCorner = Corner_LeftUp;
   CurrentTimeFrameOK = false;
   TimeFrame = Period();
   oldTime = 0;
   TradeSimulatorFinished = false;

   IndicatorShortName(windowsName);
   SetIndexLabel(0,windowsName);
   
   //-- clear Titles
   for (int i=0; i<=50; i++) {
      Title1[i] = "";
      Title2[i] = "";
   }
   //-- clear Time Frames
   for (i=0; i<=10; i++) {
      iTimeFrame[i] = 0;
      sTimeFrame[i] = "";
      SumeEquity[i] = 0;
   } 

   
//----
   return(0); 
}


//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{  
   Delete_TextObjects();
   Sleep(500);
   Delete_TextObjects();   
//----
   return(0);
}

void Delete_TextObjects()
{
   ObjectsDeleteAll(1,OBJ_LABEL);
   ObjectsDeleteAll(1,OBJ_TEXT);
   ObjectsDeleteAll(1,OBJ_ARROW);
   return;
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
{datetime czas=0;
if (czas==iTime(NULL,ActTF,0)&& ActTF>-1) return(0);
    czas=iTime(NULL,ActTF,0);
   
   //if (TradeSimulatorFinished) return(0);

//----   
   iWindow = WindowFind(windowsName);
   if (iWindow==-1) iWindow=1;

   //---- titles
     
   Get_PairListNames();   
//   Get_TimeFrameListValues();
   Get_SystemListNames();
   Set_Initialisations();   
   Show_TitlesUpper();
   Show_TitlesLeft(); 
   
   //---- indicators 
   Get_IndicatorValues();
   Get_SumeEquity();
      
   Write_CurrentTime(xCurrentTime, yCurrentTime);   
//----
   //TradeSimulatorFinished = true;
   return(0);
}
//+------------------------------------------------------------------+

//####################################################################
//+------------------------------------------------------------------+
//|   Initialisations
//+------------------------------------------------------------------+

void Set_ColumnNumbers()
{
   int iCol = 1;
   colDB_Pairs  = iCol; iCol = iCol +1;
   colDB_Spread = iCol; iCol = iCol +1;

   colDB_Close = iCol; //iCol = iCol +1;
   colDB_LastPrice = iCol; iCol = iCol +1;
   colDB_M5  = iCol; iCol = iCol +1;
   colDB_M15 = iCol; iCol = iCol +1;
   colDB_M30 = iCol; iCol = iCol +1;
   colDB_H1  = iCol; iCol = iCol +1;
   colDB_H4  = iCol; iCol = iCol +1;
   colDB_D1  = iCol; iCol = iCol +1;
   colDB_W1  = iCol; iCol = iCol +1;
}

void Set_Initialisations()
{
   int i, iCol;
   Set_ColumnNumbers();
   string thisTimeFrame = Get_sPeriod(Period());   
   //-- Titles 1 .....................................................
   Title1[colDB_Pairs] = "Pairs:";
   Title1[colDB_Spread] = "Pair";
   Title1[colDB_Close] = "Profit";
   //Title1[colDB_LastPrice] = "Current";   
   
   //-- Title 1 => TimeFrames (Systems)
   
   iColDB_First = colDB_LastPrice + 1;
   for (i=0; i<=NumberSystems; i++) {
      //sTimeFrame[i] = Get_sPeriod(iTimeFrame[i]);   
      sTimeFrame[i]=Systems[i];
      Title1[iColDB_First + i] = StringSubstr(sTimeFrame[i],0,col_display);
      Title2[iColDB_First + i] = StringSubstr(sTimeFrame[i],col_display);
      //Print(sTimeFrame[i]);
   }   
 
 
 
   //-- Titles 2   
   Title2[colDB_Spread] = "Sprd";
   Title2[colDB_Close] = "all Sys";
   //Title2[colDB_LastPrice] = "Price";   

   //---- x Columns ..................................................  
   xCol[colDB_Pairs]  = xLeftTitle;
   xCol[colDB_Spread] = xCol[colDB_Pairs] + colStep + 40;
   xCol[colDB_Close]  = xCol[colDB_Spread] + colStep;
   xCol[colDB_LastPrice] = xCol[colDB_Close];// + colStep;

   newColStep = colStep;
   
   //iCol = colDB_Close;   
   iCol = colDB_LastPrice+1;   
   xCol[iCol] = xCol[iCol-1] + colStepTimeFrames + 10;
   
   for (i=iCol+1; i<nTitles; i++)
      xCol[i] = xCol[i-1] + newColStep;

   //---- y Rows .....................................................
   yRow[0] = yTitle2 + rowStep;
   for (i=1; i<=NumberSymbols; i++)
      yRow[i] = yRow[i-1] + rowStep;
}

void Show_TitlesUpper()   
{  
   int xx1, xx2;
   for (int i=1; i<nTitles; i++) {
      xx1 = xCol[i];
      xx2 = xx1;
      //-- Adjust xCol
      if (i==colDB_Close) xx1 = xx1 - 3;
     
      if (Title1[i] != "") 
        SetLabelObject(sLabelCode+"Title1_"+i, Title1[i],  colorTitle, xx1, yTitle1);
      if (Title2[i] != "")
        SetLabelObject(sLabelCode+"Title2_"+i, Title2[i],  colorTitle, xx2, yTitle2);        
   }      
}

void Show_TitlesLeft()
{
   for (int i=0; i<NumberSymbols; i++) { 
      string sSymbol = Pair[i];
      int j = i+1;
      if (j<10) string sNr = "0" + j + ". "; else sNr = j + ". ";
      string sNrSymbol = sNr + sSymbol;
      //-- Names
      SetLabelObject(sLabelCode+sSymbol, sNrSymbol, colorTitle, xLeftTitle, yRow[i]);
      //-- Spreads
      string Spread = DoubleToStr(MarketInfo(sSymbol, MODE_SPREAD),0);
      SetLabelObject(sLabelCode+sSymbol+"_Spread", Spread, colorTitle, xCol[colDB_Spread]+10, yRow[i]);
   }   
   //~~Show_OnlyPrices();
}

/*void Show_OnlyPrices()
{
   double dClose, dOpen;
   color dColor;
   string sSymbol;
   
   for (int i=0; i<NumberSymbols; i++) { 
      sSymbol = Pair[i];
      int iDigits = MarketInfo(sSymbol,MODE_DIGITS);
     
      //-- Last Close
      //int iDigits = MarketInfo(sSymbol,MODE_DIGITS);
      //double dClose = iClose(sSymbol,TimeFrame,ShiftSignals);
      //double dOpen  = iOpen(sSymbol,TimeFrame,ShiftSignals);
      //if (dClose >= dOpen) color dColor = Green; else dColor = Red;      
      //SetLabelObject(sLabelCode+Pair[i]+"_LastClose", DoubleToStr(dClose,iDigits),  dColor, xCol[colDB_Close], yRow[i]);
      
      //-- Current Price
      dClose = iClose(sSymbol,TimeFrame,0);
      dOpen = iOpen(sSymbol,TimeFrame,0);
      PairPrice[i] = dClose;
      if (dClose >= dOpen) dColor = Green; else dColor = Red;      
      SetLabelObject(sLabelCode+Pair[i]+"_CurrClose", DoubleToStr(dClose,iDigits),  dColor, xCol[colDB_LastPrice], yRow[i]);
   }   
}*/

void Write_CurrentTime(int xx, int yy)
{
   string sTime = TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES|TIME_SECONDS);
   string sTimeFrame = Get_sPeriod(TimeFrame);
   string st = sTime+"   "+Symbol() + " ," + sTimeFrame;
   
//   if (UseOnlyATRfactors_forSLTP)
//   st = st + "  (" + " fctSL=" + DoubleToStr(ATRFactor_SL,1) + "  fctTP=" + DoubleToStr(ATRFactor_TP,1)  +" ATR)";
//   else
//   st = st + "  (" + " fctSL=" + DoubleToStr(ATRFactor_SL,1) + "  fctTP=" + DoubleToStr(ATRFactor_TP,1)  +")";
    
   SetTimeObject(sLabelCode+"time", st, colorTime, xx, yy);
}



//####################################################################
//+------------------------------------------------------------------+
//| Create Title
//+------------------------------------------------------------------+
void SetLabelObject(string sName, string sText, color dColor, int xx, int yy)
{
   ObjectCreate(sName, OBJ_LABEL, iWindow, 0, 0);
        ObjectSetText(sName,sText,10, "Arial Bold", dColor);
        ObjectSet(sName, OBJPROP_CORNER, iCorner);
        ObjectSet(sName, OBJPROP_XDISTANCE, xx);
        ObjectSet(sName, OBJPROP_YDISTANCE, yy);
}

void SetTimeObject(string sName, string sText, color dColor, int xx, int yy)
{
   ObjectCreate(sName, OBJ_LABEL, iWindow, 0, 0);
        ObjectSetText(sName,sText,7, "Arial Bold", dColor);
        ObjectSet(sName, OBJPROP_CORNER, iCorner);
        ObjectSet(sName, OBJPROP_XDISTANCE, xx);
        ObjectSet(sName, OBJPROP_YDISTANCE, yy);
}

//####################################################################
//+------------------------------------------------------------------+
//|      Get PairList Names
//+------------------------------------------------------------------+
void Get_PairListNames()
{
   int i,j,k;
   string CurSymbol;
   
   for (i=0, j=0, k=1; i<nTitles && k>0;)
   {
      k=StringFind(PairsList,",",j);
      if (k==0) CurSymbol=StringSubstr(PairsList,j,0);
      else CurSymbol=StringSubstr(PairsList,j,k-j);
      CurSymbol = CurSymbol + SymbolSuffix;
      //---- check if the pair is allowable
      double dClose = iClose(CurSymbol,TimeFrame,0);      
      if (dClose > 0.0) {
         Pair[i]=CurSymbol;
         i++;
      }
  
      j=StringFind(PairsList,",",j)+1;
      if (j==0) break;
   }
   NumberSymbols = i;

   return;
}

void Get_SystemListNames()
{
   int i,j,k;
   string CurSystem;
   
   for (i=0, j=0, k=1; i<nTitles && k>0;)
   {
      k=StringFind(SystemList,",",j);
      if (k==0) CurSystem=StringSubstr(SystemList,j,0);
      else CurSystem=StringSubstr(SystemList,j,k-j);
      
      //---- check if the pair is allowable
      
      
         Systems[i]=CurSystem;
         i++;
      
  
      j=StringFind(SystemList,",",j)+1;
      if (j==0) break;
   }
   NumberSystems = i-1;

   return;
}







//void Get_TimeFrameListValues()
//{
//   int i,j,k;
//   string CurTimeFrame;
   
//   for (i=0, j=0, k=1; i<nTitles && k>0;)
//   {
//      k=StringFind(TimeFrameList,",",j);
// /     if (k==0) CurTimeFrame=StringSubstr(TimeFrameList,j,0);
//      else CurTimeFrame=StringSubstr(TimeFrameList,j,k-j);   
//        
//      iTimeFrame[i] = StrToInteger(CurTimeFrame);
//      i++;
          
//      j=StringFind(TimeFrameList,",",j)+1;
//      if (j==0) break;
//   }
//   NumberTimeFrames = i-1;

//   return;
//}

//####################################################################
//+------------------------------------------------------------------+
//|      Get Indicator Values
//+------------------------------------------------------------------+
void Get_IndicatorValues()
{
   //int iArrow, iHeight=8, iHeightSignal = 10, xStep=8;
   
   for (int ii=0; ii<=10; ii++) {
      
      SumeEquity[ii] = 0;}
   for ( ii=0; ii<=30; ii++) {
      
      SumPairs[ii] = 0;}
   
   color dColor;
   //for (int i=NumberSymbols-1; i>=0; i--) { 
   for (int i=0; i<NumberSymbols; i++) { 
      string sSymbol = Pair[i];


      for (int col = 0; col <= NumberSystems; col++) {         
            string sSystem = Systems[col];
            bool isSystem;
         double dEquity = dSystemEquity(sSystem,sSymbol,isSystem);
         
         //iCustom(sSymbol,iTimeFrame[col],sNameTradeSimulator,
         //     Begin_Backtest,UseOnlyATRfactors_forSLTP,false,
         //     ATRFactor_SL,ATRFactor_TP,SAR_Step,SAR_Max, Take2ParabolicSignals,SAR_Step2,SAR_Max2,
         //     0,0);
      
      
         SumeEquity[col] = SumeEquity[col] + dEquity;
         EquityPairs[i][col] = dEquity;
         
         int xx = xCol[iColDB_First + col];
         
         if (dEquity > 0.0) dColor = colorPlusEquity; else  if (dEquity==0) dColor=colorZeroEquity; else dColor = colorMinusEquity;
         
         string sPrice = DoubleToStr(dEquity,2);
         if (isSystem==false) sPrice="  ";
         
         int yy = yRow[i];
         yLastRow = yy;
         SetLabelObject(sLabelCode+sSymbol+"_Eq"+sTimeFrame[col], sPrice, dColor, xx, yy);         
      }
   }
   //-- Sume horizontal
   for (i=0; i<NumberSymbols; i++) {      
      for (col = 0; col <= NumberSystems; col++) {         
         dEquity = EquityPairs[i][col];
         SumPairs[i]= SumPairs[i] + dEquity;
      }
   }
   //-- write results
   for (i=0; i<NumberSymbols; i++) { 
      sSymbol = Pair[i];            
      dEquity = SumPairs[i];       
      
      xx = xCol[colDB_Close];
      if (dEquity > 0.0) dColor = colorPlusEquity; else  if (dEquity==0) dColor=colorZeroEquity; else dColor = colorMinusEquity;
      //if (dEquity > 0.0) dColor = colorPlusEquity; else  dColor = colorMinusEquity;
      sPrice = DoubleToStr(dEquity,2);
      yy = yRow[i];      
      SetLabelObject(sLabelCode+sSymbol+"_EqSH"+sTimeFrame[col], sPrice, dColor, xx, yy);      
   }
}

void Get_SumeEquity()
{
   double sumPoints = 0.0;
   double sumAverage = 0.0;
   //-- Sume Equity
   int xx = xCol[colDB_LastPrice];
   //int xx = xCol[colDB_Close];
   int yy1 = yLastRow + rowStep + 10;   
   SetLabelObject(sLabelCode+"_SEqSum", "System Profit:", colorTitle, xx, yy1);
   int yy2 = yy1 + rowStep;
   //SetLabelObject(sLabelCode+"_SEqAvg", "Average:", colorTitle, xx, yy2);
   int yy3 = yy2 + rowStep;
   
   SetLabelObject(sLabelCode+"_SEqSumP", "Total Profit:", colorTitle, xx, yy3);
 //  int yy4 = yy3 + rowStep;
  //  SetLabelObject(sLabelCode+"_SEqAvgP", "SumAvgPnts:", colorTitle, xx, yy4);
 
   //-- vertical sum  
 
   for (int col = 0; col <= NumberSystems; col++) {         
      double dEquity = SumeEquity[col];
      sumPoints = sumPoints + dEquity;
         
      xx = xCol[iColDB_First + col];      
      
      string sPrice = DoubleToStr(dEquity,2);
      color dColor;
   //   if (dEquity > 0) color dColor = colorPlusEquity; else dColor = colorMinusEquity;
      if (dEquity > 0.0) dColor = colorPlusEquity; else  if (dEquity==0) dColor=colorZeroEquity; else dColor = colorMinusEquity;
      SetLabelObject(sLabelCode+"_SEq"+sTimeFrame[col], sPrice, dColor, xx, yy1);
      
      double dAverage = dEquity/NumberSymbols;
      sumAverage = sumAverage + dAverage;
     sPrice = DoubleToStr(dAverage,2);
     //if (dEquity > 0) dColor = colorPlusEquity; else dColor = colorMinusEquity;
     if (dEquity > 0.0) dColor = colorPlusEquity; else  if (dEquity==0) dColor=colorZeroEquity; else dColor = colorMinusEquity;
    // SetLabelObject(sLabelCode+"_SEqMid"+sTimeFrame[col], sPrice, dColor, xx, yy2);
   }  
   //-- total sum points and averages
   xx = xCol[iColDB_First];
   sPrice = DoubleToStr(sumPoints,2);
   if (sumPoints > 0) dColor = colorPlusEquity; else dColor = colorMinusEquity;
   SetLabelObject(sLabelCode+"_SEqPv", sPrice, dColor, xx, yy3);
   
   //sPrice = DoubleToStr(sumAverage,2);
   //if (sumAverage > 0) dColor = colorPlusEquity; else dColor = colorMinusEquity;
 //  SetLabelObject(sLabelCode+"_SEqMidv", sPrice, dColor, xx, yy4);
}
//####################################################################
string Get_sPeriod(int timeframe)
{
   if (timeframe == PERIOD_M1) return("M1");
   if (timeframe == PERIOD_M5) return("M5");
   if (timeframe == PERIOD_M15) return("M15");
   if (timeframe == PERIOD_M30) return("M30");
   if (timeframe == PERIOD_H1) return("H1");
   if (timeframe == PERIOD_H4) return("H4");
   if (timeframe == PERIOD_D1) return("D1");
   if (timeframe == PERIOD_W1) return("W1");
   if (timeframe == PERIOD_MN1) return("MN1");
}

//####################################################
double dSystemEquity(string sSystem,string sSymbol,bool& isSystem)
 {int i,total;
   //Print(sSymbol,sSystem);
  	double totalProfits = 0.0;
  	total=OrdersTotal();
  	isSystem=false;
  	sSystem=StringTrimRight(StringTrimLeft(sSystem));
	for (i=0; i<total;i++)
	{
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      //Print(sSymbol," ",sSystem," ","Find :",StringFind(OrderComment(),sSystem),OrderComment());
      if (sSystem!="" && OrderSymbol()==sSymbol && StringFind(OrderComment(),sSystem)>-1)
      {
               
         switch (OrderType())
         {
         case OP_BUY:
            isSystem=true;
            totalProfits += OrderProfit();
            break;
            
         case OP_SELL:
            isSystem=true;
            totalProfits += OrderProfit();
            break;
         }   
      }
	}
	return (totalProfits);
}